#include "audiolib.h"
#include "winlib.h"
#include "serverlib.h"
#include "clientlib.h"
#include <vector>


const string Stop   = "STOP";
const string Pause = "PAUSE";
const string Quit   = "QUIT";
const string Jump  = "JUMP";
const string Next   = "NEXT";
const string Prev   = "PREV";

void main(int argc,char  **argv)
{
vector<string> Input(4);
string ip,mode;
int port = -1;
bool y_ip = false ,y_mode = false,server = false , client = false, local = false ;

/*Testear modo */

if(argc > 7)
	{
	cout << "Error: Demasiados parmetros" << endl;
	exit(1);
	}
else
if(argc == 1)
	local = true;

for(int i = 1 ; i < argc ; i++)
	{
	if((strcmp(*(argv + i),"-h") == 0)  &&  (i+1) < argc)
		{
		ip = *(argv + i +1);
		i++;
		y_ip = true;
		}
	else
	if((strcmp(*(argv + i),"-m") == 0)  &&  (i+1) < argc)
		{
		mode = *(argv + i +1);
		if(mode != "local" && mode != "server" && mode != "client" )
			{
			cout << "Error : Modo desconocido" << endl;
			exit(1);
			}
		i++;
		y_mode = true;
		}
	else
	if((strcmp(*(argv + i),"-p") == 0)  &&  (i+1) < argc)
		{
		port =atoi(*(argv + i +1));
		i++;
		}
	else
		{
		cout << "Error: Parmetro desconocido " << *(argv+i) << endl;
		exit(1);
		}
	}

if( y_ip && !y_mode)
	{
	cout << "Error : Debe especificar modo de funcionamiento" << endl;
	exit(1);
	}
else
if( !y_ip && y_mode && mode != "local")
	{
	cout << "Error : Debe especificar una direccin IP o un nombre de host" << endl;
	exit(1);
	}
else
if( y_ip && y_mode && mode == "local")
	{
	cout << "Error : Modo local no requiere IP" << endl;
	exit(1);
	}
else
if(mode == "local")
	local = true;
else
if(mode== "client")
	client = true;
else
if(mode == "server")
	server = true;

/*Fin Test*/


Win MainWin,*P2MainWin;
Server Daemon,*P2Daemon;
Client Get,*P2Get;
Audio System, *P2System;
Mp3 Media,*P2Media;
map<int,int>info;
map<int,string>FilesOfClient;
int key = 0;

if(local)
	{
	P2System = &System;
	P2Media   = &Media;

	if(!P2System->Init())
		{
		cout << "Error : No se pudo iniciar el daemon de sonido" << endl;
		exit(-1);
		}
	P2System->GetVolume();
	P2MainWin = &MainWin;
	P2MainWin->Init();
	P2Media->Init();
	P2MainWin->FileWin(".");
	P2MainWin->MoveWin(0);
	P2MainWin->ShowVol( P2System->GetVolume() );
	}
else
if(client)
	{
	P2Get = &Get;
	cout << "Conectando ...." << endl;
	if(P2Get->Init(ip,port))
		{
		cout << "Error : No se pudo conectar el servidor remoto" << endl;
		exit(-1);
		}
	P2Get->Request(1,0);
	if(!P2Get->Answer(FilesOfClient))
		{
		cout << "Error : El servidor no posee una lista de reproduccin" ;
		exit(-1);
		}
	P2MainWin = &MainWin;
	P2MainWin->Init();
	P2MainWin->FileWin(FilesOfClient,ip);
	P2MainWin->MoveWin(0);
	}
else
if(server)
{
	P2System = &System;
	P2Media   = &Media;

	if(!P2System->Init())
		{
		cout << "Error : No se pudo iniciar el daemon de sonido" << endl;
		exit(-1);
		}

	P2System->GetVolume();
	P2Daemon = &Daemon;

	if(!P2Daemon->Init(ip,port))
		{
		cout << "Error : No se pudo iniciar el servicio" << endl;
		exit(1);
		}
	P2Media->Init();
while(true)
	{
	string todo,action,key;
	todo = P2Daemon->Accept();
	usleep(1);
	if(todo != "@EOF")
		{
		key = todo.substr(0,todo.find("@"));
		todo = todo.erase(0,todo.find("@")+1);
		action = todo.substr(0,todo.find("\n"));
		switch(atoi(action.c_str()))
			{
			case 88:
				P2Media->Open(P2Daemon->ToPlay(key));
				break;
			case 86:
				P2Media->Action(Stop,0);
				break;
			}
		}
	}
}

while(true)
	{
	if(local)
		{
		key = P2MainWin->GetCh();
		usleep(1);
		if(P2Media->GetInfo())
			{
			P2Media->HandleInfo(info);
			P2MainWin->WriteInfo(info);
			}
		switch(key)
			{
			case 81 : case 113 :                      //QUIT
				P2MainWin->Kill();
				P2Media->Action(Quit,0);
				P2Media->Kill();
				P2System->Kill();
				exit(0);
				break;
			case 66 : case 98  :                      //NEXT
				P2Media->Open(Next);
				break;
			case 67 : case 99  :                      //PAUSE
				P2Media->Action(Pause,0);
				break;
			case 86 : case 118 :                      //STOP
				P2Media->Action(Stop,0);
				break;
			case 88 : case 120 :                      //PLAY
				P2Media->Open(P2MainWin->ToPlay());
				break;
			case 90 : case 122 :                      //PREV
				P2Media->Open(Prev);
				break;
			case 77 :	case 109 :                    //FF
				P2Media->Action(Jump,200);
			case 78 : case 110 :
				P2Media->Action(Jump,-200); //RW
				break;
			case 79 : case 111 : case KEY_UP:
				P2MainWin->MoveWin(UP);
				break;
			case 76 : case 108 : case KEY_DOWN:
				P2MainWin->MoveWin(DOWN);
				break;
			case 65 : case 97  :
				P2Media->Add(P2MainWin->ToPlay());
				break;
			case 10:
				P2MainWin->ChDir();
				break;
			case 43:
				P2MainWin->ShowVol(P2System->SetVolume(1));
				break;
			case 45:
				P2MainWin->ShowVol(P2System->SetVolume(-1));
				break;
			}
		}
	else
	if(client)
		{
		key = P2MainWin->GetCh();
		usleep(1);
		if(key > 0)
			{
			switch(key)
				{
				case 81 : case 113 :                      //QUIT
					P2MainWin->Kill();
					exit(0);
					break;
				case 88 : case 120 :                      //PLAY
					P2Get->Request(P2MainWin->ToSend()-6,88);
				break;
				case 86 : case 118 :                      //STOP
					P2Get->Request(P2MainWin->ToSend()-6,86);
				break;
				}
			}
		}
	}

exit(0);

}
